#pragma once

#include "CoreMinimal.h"
#include "BasicChargeableInteraction.h"
#include "RemoteHookChargingInteraction.generated.h"

class AActor;
class UChargeableComponent;

UCLASS(Blueprintable, Abstract, EditInlineNew, meta=(BlueprintSpawnableComponent))
class ANNIVERSARY2024_API URemoteHookChargingInteraction : public UBasicChargeableInteraction
{
	GENERATED_BODY()

private:
	UPROPERTY(BlueprintReadWrite, Replicated, Transient, meta=(AllowPrivateAccess=true))
	AActor* _currentTarget;

private:
	UFUNCTION(BlueprintCallable, Server, Reliable)
	void Server_SetCurrentTarget(AActor* target);

	UFUNCTION(BlueprintCallable)
	void OnDechargeEnd(UChargeableComponent* chargeableComponent);

	UFUNCTION(BlueprintCallable)
	void OnDechargeBegin(UChargeableComponent* chargeableComponent);

protected:
	UFUNCTION(BlueprintCallable, BlueprintImplementableEvent, BlueprintCosmetic)
	void Cosmetic_StopCharge();

	UFUNCTION(BlueprintCallable, BlueprintImplementableEvent, BlueprintCosmetic)
	void Cosmetic_StartCharge();

	UFUNCTION(BlueprintCallable, BlueprintImplementableEvent, BlueprintCosmetic)
	void Cosmetic_ChargeComplete();

public:
	virtual void GetLifetimeReplicatedProps(TArray<FLifetimeProperty>& OutLifetimeProps) const override;

public:
	URemoteHookChargingInteraction();
};

FORCEINLINE uint32 GetTypeHash(const URemoteHookChargingInteraction) { return 0; }
